'-----------------------------------------------------------------------
'                        U S I N G   C L A S S E S  P A R T  3

'                                         Ron Kessler

'                                    Created 3/20/08

'-----------------------------------------------------------------------

'===================================
'History of changes:

'3/20/08  Modified to work with a property in the DoMath Class
'               Also uses one event handler to manage all radio buttons!

'===================================


Option Explicit On

Public Class frmMain

    Dim myCalculator As New DoMath         'instantiate my custom class 


#Region "Which Math Function?"
    '---find out what type of operation they want to do...
    '    One sub handles all radio buttons! Just rename the sub to make more sense then add all the controls to the
    '    handles clause!
    '    I use the name of the control that triggered this event. I get the name from the "sender" parameter.
    '   You create a temp object as the type of control you are working with.

    Private Sub whichOperation(ByVal sender As System.Object, ByVal e As System.EventArgs) _
        Handles optAdd.CheckedChanged, optSubtract.CheckedChanged, _
                    optMultiply.CheckedChanged, optDivide.CheckedChanged

        Dim whichRdoButton As RadioButton = sender       'do not use the new keyword!

        Select Case whichRdoButton.Name.ToString
            Case "optAdd"
                myCalculator.Operation = "+"       'set property for addition
            Case "optSubtract"
                myCalculator.Operation = "-"
            Case "optMultiply"
                myCalculator.Operation = "*"
            Case "optDivide"
                myCalculator.Operation = "/"
        End Select


    End Sub
#End Region

#Region "Compute"
    '---now compute the answer
    Private Sub btnCompute_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCompute.Click

        Try
            Dim firstNumber As Double = 0              'the 1st number they enter
            Dim secondNumber As Double = 0         'secondNumber number they enter
            Dim myAnswer As Double = 0                'hold the answer

            '---test, assign, and manage errors all in one place!
            If Not Double.TryParse(txtNumber1.Text, firstNumber) Then
                Throw New Exception
            ElseIf Not Double.TryParse(txtNumber2.Text, secondNumber) Then
                Throw New Exception
            End If


            '---use the function DoCompute inside the Class Module called DoMath.vb
            myAnswer = myCalculator.DoCompute(firstNumber, secondNumber)
            txtAnswer.Text = myAnswer.ToString

        Catch err As Exception
            MessageBox.Show("Sorry, but I can't manage that operation...try again.", "System Message", MessageBoxButtons.OK, MessageBoxIcon.Error)
            btnClear.PerformClick()      'simulates clicking the clear button!
            txtNumber1.Focus()

        End Try
    End Sub
#End Region

#Region "Clear"
    Private Sub btnClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClear.Click
        '---this sub finds all the textboxes on the form and clears them! It searches through the controls collection and when
        '    it finds a textbox, it clears it.
        '---dim a temp object variable as a control object. It can be a button, listbox, textbox, etc.
        Dim myControl As New Control


        '---now loop through the form's control collection to find all the textboxes.
        For Each myControl In Controls
            If TypeOf myControl Is TextBox Then
                myControl.Text = ""
            End If
        Next

        txtNumber1.Focus()
    End Sub
#End Region

#Region "Close"
    Private Sub btnEnd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEnd.Click
        Me.Close()
    End Sub
#End Region

End Class
